Option Explicit 

Dim oArgs : Set oArgs = WScript.Arguments
Dim sArgs
Dim iCnt

'Debug Main Parameters
WScript.Echo "#--------------------------------------------------------------------------------#"
WScript.Echo "# System Properties verification tool v1.00 (TuS)                                #"
WScript.Echo "#--------------------------------------------------------------------------------#"

If oArgs.Count <> 1 Then
	WScript.Echo "  Usage: VerifyProberties.vbs <FullPath_to_Mp3File>"
	WScript.Echo "#--------------------------------------------------------------------------------#"
	WScript.Quit
End If

WScript.Echo "  Processing with "& oArgs.Count & " Input Arguments:"
For iCnt = 0 To oArgs.Count -1 
	WScript.Echo"    - Argument " & iCnt & ": " & oArgs(iCnt)
Next	
WScript.Echo ""

'Get file info
Dim PATH : PATH = Left(oArgs(0), InStrRev(oArgs(0),"\")-1)
Dim NAME : NAME = Right(oArgs(0), Len(oArgs(0))-InStrRev(oArgs(0),"\"))

'Query the system properties
GetDetailsOf PATH,NAME
WScript.Echo "#--------------------------------------------------------------------------------#"

Function GetDetailsOf(sPath, sFile)  
	dim objShell, objFolder, objFolderItem, objInfo, objNullFolderItem
	Dim iCnt, ret
	
	Set objShell = CreateObject("Shell.Application") 
	
	On error Resume Next
	Set objNullFolderItem = objFolder.ParseName("") 

	Set objFolder = objShell.NameSpace(sPath)  
		If Not(IsNothing(objFolder)) then
		Set objFolderItem = objFolder.ParseName(sFile) 
		
			If Not(IsNothing(objFolderItem)) then    
				 
				WScript.echo  "  ID   | Property Name                 |  Property Value"
				WScript.echo  "-------+-------------------------------+-----------------------------------------+"

				iCnt = 0
				ret = ""
				
				Do While (iCnt < 400)
					ret = objFolderItem.ExtendedProperty(objFolder.GetDetailsOf(objNullFolderItem, iCnt))
					WScript.echo  " [" & iCnt & Space(3-Len(iCnt))& "] | " & objFolder.GetDetailsOf(objNullFolderItem, iCnt) & Space(30-Len(objFolder.GetDetailsOf(null, iCnt))) & "| "  & objFolder.GetDetailsOf(objFolderItem, iCnt)
					iCnt = iCnt + 1
				Loop
			 Else
			 	 WScript.Echo "   Unable to connect to file " & sFile 
			 End If    
		 Set objFolderItem = Nothing 
		 Else
		 	WScript.Echo "   Unable to connect to folder " & sPath
		 
		 End If  
	 Set objFolder = Nothing  
	 Set objShell = Nothing
End Function
 
Function IsNothing (Obj)
	'**********************************************************************************
	' Purpose : Check if object is Nothing
	'**********************************************************************************
	If TypeName(Obj) = "Nothing" Then
		IsNothing = True
	Else
		IsNothing = False
	End If
End Function